﻿using Microsoft.EntityFrameworkCore.Metadata.Internal;
using System.ComponentModel.DataAnnotations.Schema;

namespace RobotSwarms.Domainprimitives
{
    [Serializable]
    public struct Coordinate : IComparable<Coordinate>
    {
        public readonly int X;
        public readonly int Y;

        [NotMapped]
        public static readonly Coordinate ZERO = new Coordinate();

        #region Contructor

        public Coordinate() : this(0,0)
        {
        }

        public Coordinate(int x, int y)
        {
            X = x;
            Y = y;
        }
        #endregion

        #region Autogenerated
        public override string? ToString()
        {
            return $"{X}/{Y}";
        }

        public static Coordinate Parse(string coordinate)
        {
            string[] strs = coordinate.Split('/'); 
            int X = int.Parse(strs[0]);
            int Y = int.Parse(strs[1]);

            Coordinate result = new(X, Y);

            return result;
        }


        public override bool Equals(object? obj)
        {
            return obj is Coordinate coordinate &&
                   X == coordinate.X &&
                   Y == coordinate.Y;
        }

        public override int GetHashCode()
        {
            return HashCode.Combine(X, Y);
        }

        public int CompareTo(Coordinate other)
        {
            double thisDistance = Math.Sqrt((this.X * this.X) + (this.Y * this.Y));
            double otherDistance = Math.Sqrt((other.X * other.X) + (other.Y * other.Y));

            if (thisDistance > otherDistance) return 1;
            else if (thisDistance < otherDistance) return -1;
            else
            {
                if (this.X > other.X) return 1;
                else if (this.X < other.X) return -1;
                else
                {
                    if (this.Y > other.Y) return 1;
                    else if (this.Y < other.Y) return -1;
                    else return 0;
                }
            }
        }
        #endregion

        #region Operator

        public static bool operator ==(Coordinate left, Coordinate right)
        {
            return left.Equals(right);
        }

        public static bool operator !=(Coordinate left, Coordinate right)
        {
            return !(left == right);
        }

        public static bool operator <(Coordinate left, Coordinate right)
        {
            return left.CompareTo(right) < 0;
        }

        public static bool operator <=(Coordinate left, Coordinate right)
        {
            return left.CompareTo(right) <= 0;
        }

        public static bool operator >(Coordinate left, Coordinate right)
        {
            return left.CompareTo(right) > 0;
        }

        public static bool operator >=(Coordinate left, Coordinate right)
        {
            return left.CompareTo(right) >= 0;
        }
        #endregion
    }
}
